<template>
  <div>
    <h3
      class="flex items-center justify-center text-center section-title bai text-primary"
    >
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="w-10 h-10 mr-5"
        viewBox="0 0 20 20"
        fill="currentColor"
      >
        <path
          fill-rule="evenodd"
          d="M6 2a2 2 0 00-2 2v12a2 2 0 002 2h8a2 2 0 002-2V4a2 2 0 00-2-2H6zm1 2a1 1 0 000 2h6a1 1 0 100-2H7zm6 7a1 1 0 011 1v3a1 1 0 11-2 0v-3a1 1 0 011-1zm-3 3a1 1 0 100 2h.01a1 1 0 100-2H10zm-4 1a1 1 0 011-1h.01a1 1 0 110 2H7a1 1 0 01-1-1zm1-4a1 1 0 100 2h.01a1 1 0 100-2H7zm2 1a1 1 0 011-1h.01a1 1 0 110 2H10a1 1 0 01-1-1zm4-4a1 1 0 100 2h.01a1 1 0 100-2H13zM9 9a1 1 0 011-1h.01a1 1 0 110 2H10a1 1 0 01-1-1zM7 8a1 1 0 000 2h.01a1 1 0 000-2H7z"
          clip-rule="evenodd"
        />
      </svg>
      {{ $t('calculator.title') }}
    </h3>

    <form
      class="grid grid-cols-1 gap-8 mb-16 text-left md:grid-cols-2 lg:grid-cols-3"
      @submit.prevent=""
    >
      <div>
        <label
          for="hashrate"
          class="block text-base font-normal text-white montserrat"
          >{{ $t('calculator.form.fields.hashrate') }}</label
        >
        <div class="relative mt-1 rounded-md shadow-sm">
          <input
            type="number"
            name="hashrate"
            id="hashrate"
            class="input bg-secondary"
            v-model.number="dataForm.hashrate"
          />
          <div
            class="absolute inset-y-0 flex items-center text-sm font-light text-white montserrat right-4"
          >
            <span>THS</span>
          </div>
        </div>
      </div>

      <div>
        <label
          for="capEner"
          class="block text-base font-normal text-white montserrat"
          >{{ $t('calculator.form.fields.consumption') }}</label
        >
        <div class="relative mt-1 rounded-md shadow-sm">
          <input
            type="number"
            name="capEner"
            id="capEner"
            class="input bg-secondary"
            v-model.number="dataForm.capEner"
          />
          <div
            class="absolute inset-y-0 flex items-center text-sm font-light text-white montserrat right-4"
          >
            <span>Kw</span>
          </div>
        </div>
      </div>

      <div>
        <label
          for="opex"
          class="block text-base font-normal text-white montserrat"
          >{{ $t('calculator.form.fields.opex') }}</label
        >
        <div class="relative mt-1 rounded-md shadow-sm">
          <input
            type="number"
            name="opex"
            id="opex"
            class="input bg-secondary"
            v-model.number="dataForm.opex"
          />
          <div
            class="absolute inset-y-0 flex items-center text-sm font-light text-white montserrat right-4"
          >
            <span>$/KwH</span>
          </div>
        </div>
      </div>

      <div>
        <label
          for="machinePrice"
          class="block text-base font-normal text-white montserrat"
          >{{ $t('calculator.form.fields.cost') }}</label
        >
        <div class="relative mt-1 rounded-md shadow-sm">
          <input
            type="number"
            name="machinePrice"
            id="machinePrice"
            class="input bg-secondary"
            v-model.number="dataForm.machinePrice"
          />
          <div
            class="absolute inset-y-0 flex items-center text-sm font-light text-white montserrat right-4"
          >
            <span>$</span>
          </div>
        </div>
      </div>

      <div>
        <label
          for="hashPrice"
          class="block text-base font-normal text-white montserrat"
          >{{ $t('calculator.form.fields.hashprice') }}</label
        >
        <div v-if="hashPrice" class="relative mt-1 rounded-md shadow-sm">
          <input
            type="number"
            name="hashPrice"
            id="hashPrice"
            class="border-transparent bg-secondary input"
            disabled="disabled"
            v-model.number="hashPrice"
            :placeholder="hashPrice"
          />
          <div
            class="absolute inset-y-0 flex items-center text-sm font-light text-white montserrat right-4"
          >
            <span>$/TH/Day</span>
          </div>
        </div>
      </div>

      <!-- <div class="flex items-end justify-end">
        <div>
          <button type="submit" class="btn btn-primary">Calcular</button>
        </div>
      </div> -->
    </form>

    <div class="pt-16 border-t border-white">
      <h4 class="text-3xl text-primary section-title">
        {{ $t('calculator.results.title') }}
      </h4>
      <div class="grid grid-cols-1 gap-8 md:grid-cols-2 lg:grid-cols-3">
        <div class="text-center lg:text-left">
          <h4 class="mb-2 text-lg text-white section-title">
            {{ $t(`calculator.results.fields['daily-income']`) }}
          </h4>
          <span class="text-2xl font-semibold text-primary montserrat"
            >$ {{ results.income.toFixed(2) }}</span
          >
        </div>

        <div class="text-center lg:text-left">
          <h4 class="mb-2 text-lg text-white section-title">{{ $t(`calculator.results.fields['daily-profit']`) }}</h4>
          <span class="text-2xl font-semibold text-primary montserrat"
            >$ {{ results.dailyProfit.toFixed(2) }}</span
          >
        </div>

        <div class="text-center lg:text-left">
          <h4 class="mb-2 text-lg text-white section-title">
            {{ $t(`calculator.results.fields['monthly-profit']`) }}
          </h4>
          <span class="text-2xl font-semibold text-primary montserrat"
            >$ {{ results.monthlyEarn.toFixed(2) }}</span
          >
        </div>

        <div class="text-center lg:text-left">
          <h4 class="mb-2 text-lg text-white section-title">
            {{ $t(`calculator.results.fields['roi-time']`) }}
          </h4>
          <span class="text-2xl font-semibold text-primary montserrat"
            >{{ results.ROITime.toFixed(2) }} meses</span
          >
        </div>

        <div class="text-center lg:text-left">
          <h4 class="mb-2 text-lg text-white section-title">
            {{ $t(`calculator.results.fields['annual-roi']`) }}
          </h4>
          <span class="text-2xl font-semibold text-primary montserrat"
            >{{ results.yearlyROI.toFixed(2) }} %</span
          >
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapActions } from 'vuex'

export default {
  name: 'AsicsCalculatorComponent',

  data() {
    return {
      dataForm: {
        hashrate: null,
        capEner: null,
        opex: null,
        machinePrice: null,
      },
      hashPrice: 0,
    }
  },

  computed: {
    results() {
      const { hashrate, capEner, opex, machinePrice } = this.dataForm
      const hashPrice = this.hashPrice

      const income = hashrate && hashPrice ? hashrate * hashPrice : 0
      const dailyProfit =
        income && capEner && opex ? income - capEner * 24 * opex : 0
      const monthlyEarn = dailyProfit ? dailyProfit * 30 : 0
      const ROITime =
        monthlyEarn && machinePrice ? machinePrice / monthlyEarn : 0
      const yearlyROI =
        monthlyEarn && machinePrice
          ? (monthlyEarn * 12 * 100) / machinePrice
          : 0

      return {
        income,
        dailyProfit,
        monthlyEarn,
        ROITime,
        yearlyROI,
      }
    },
  },

  async fetch() {
    const hashPrice = await this.getHashPrice()
    this.hashPrice = parseFloat(hashPrice)
  },

  methods: {
    ...mapActions({
      setCalculatorState: 'setCalculatorState',
      setAsicsSelection: 'setAsicsSelection',
    }),

    eToNumber(num) {
      let sign = ''
      ;(num += '').charAt(0) == '-' && ((num = num.substring(1)), (sign = '-'))
      let arr = num.split(/[e]/gi)
      if (arr.length < 2) return sign + num
      let dot = (0.1).toLocaleString().substr(1, 1),
        n = arr[0],
        exp = +arr[1],
        w = (n = n.replace(/^0+/, '')).replace(dot, ''),
        pos = n.split(dot)[1] ? n.indexOf(dot) + exp : w.length + exp,
        L = pos - w.length,
        s = '' + BigInt(w)
      w =
        exp >= 0
          ? L >= 0
            ? s + '0'.repeat(L)
            : r()
          : pos <= 0
          ? '0' + dot + '0'.repeat(Math.abs(pos)) + s
          : r()
      L = w.split(dot)
      if ((L[0] == 0 && L[1] == 0) || (+w == 0 && +s == 0)) w = 0 //** added 9/10/2021
      return sign + w
      function r() {
        return w.replace(new RegExp(`^(.{${pos}})(.)`), `$1${dot}$2`)
      }
    },

    async getHashPrice() {
      const data = await fetch('https://api.minerstat.com/v2/coins?list=BTC', {
        method: 'GET',
        redirect: 'follow',
      })
        .then((response) => response.json())
        .then((result) => result[0])
        .catch((error) => console.log('error', error))

      // console.log(data)

      const { price, reward_block, network_hashrate } = data

      const totalReward = price * reward_block
      // console.log(totalReward, 'totalReward')

      const totalHashrateETH = network_hashrate
      // console.log(totalHashrateETH, 'totalHashrateETH')

      const totalHashrateTH = parseFloat(
        this.eToNumber(totalHashrateETH / 1000000000000)
      )
      // console.log(totalHashrateTH, 'totalHashrateTH')

      const hashPrice = parseFloat(
        this.eToNumber((totalReward / totalHashrateTH) * 144)
      )
      // console.log(hashPrice, 'hashPrice')

      if (process.env.NODE_ENV === 'development') {
        console.log(hashPrice)
      }
      return hashPrice
    },
  },
}
</script>
